﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Data.SqlClient;
using System.Text;
using System.Xml;

/// <summary>
/// Written By S. Enes Pekkaya
/// 
/// Website : http://www.enespekkaya.com
/// </summary>
public partial class WebServices_RssNews : System.Web.UI.Page
{
    XmlTextWriter xrFeed;
    public SqlConnection connection;
    public SqlCommand command;
    public SqlDataReader datareader;

    protected void Page_Load(object sender, EventArgs e)
    {
        this.createXml();
        this.gettingData();
        this.endOfXml();

    }

    private void createXml()
    {
        Response.Clear();
        Response.ContentType = "application/rss+xml;";
        xrFeed = new XmlTextWriter(Response.OutputStream, Encoding.UTF8);
        xrFeed.WriteStartDocument();
        xrFeed.WriteStartElement("rss");
        xrFeed.WriteAttributeString("version", "2.0");
        xrFeed.WriteStartElement("channel");
        xrFeed.WriteElementString("title", "EnesPekkaya.com | Rss");
        xrFeed.WriteElementString("link", "http://www.enespekkaya.com");
        xrFeed.WriteElementString("ttl", "10");
        xrFeed.WriteElementString("description", "EnesPekkaya.Com da yayınlanan son 10 yazıyı buradan takip edebilirsiniz.");
    }

    private void gettingData()
    {
        try
        {
            String sql = "SELECT TOP 10 Id, Title, Explanation, AddingDate FROM Data";
            connection = new SqlConnection(ConfigurationManager.ConnectionStrings["connectionString"].ConnectionString);
            connection.Open();
            command = new SqlCommand(sql, connection);
            datareader = command.ExecuteReader();

            while (datareader.Read())
            {
                xrFeed.WriteStartElement("item");
                xrFeed.WriteElementString("title", datareader.GetString(1));
                xrFeed.WriteElementString("description", datareader.GetString(2));
                xrFeed.WriteElementString("link", "http://www.enespekkaya.com/News.aspx?N=" + datareader.GetInt32(0));
                xrFeed.WriteElementString("guid", "http://www.enespekkaya.com/News.aspx?N=" + datareader.GetInt32(0));
                xrFeed.WriteElementString("pubDate", datareader.GetDateTime(3).ToString("R"));
                xrFeed.WriteEndElement();
            }

            datareader.Close();
            connection.Close();
        }
        catch
        {
            Response.Write("Geçersiz Rss Feed.");
        }
    }

    private void endOfXml()
    {
        xrFeed.WriteEndElement();
        xrFeed.WriteEndElement();
        xrFeed.WriteEndDocument();
        xrFeed.Flush();
        xrFeed.Close();
        Response.End();
    }
}
